// file      : xsd/cxx/tree/traits.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#if defined(XSD_USE_CHAR) || !defined(XSD_USE_WCHAR)

#ifndef XSD_CXX_TREE_TRAITS_IXX_CHAR
#define XSD_CXX_TREE_TRAITS_IXX_CHAR

namespace xsd
{
  namespace cxx
  {
    namespace tree
    {
      template <>
      inline
      traits<bool>::type traits<bool>::
      create<char> (xml::dom::element<char> const& e)
      {
        return (e.value () == "true") || (e.value () == "1");
      }

      template <>
      inline
      traits<bool>::type traits<bool>::
      create<char> (xml::dom::attribute<char> const& a)
      {
        return (a.value () == "true") || (a.value () == "1");
      }

      template <>
      inline
      traits<bool>::type traits<bool>::
      create<char> (std::basic_string<char> const& s,
                    xml::dom::element<char> const&)
      {
        return (s == "true") || (s == "1");
      }
    }
  }
}

#endif // XSD_CXX_TREE_TRAITS_IXX_CHAR
#endif // XSD_USE_CHAR


#if defined(XSD_USE_WCHAR) || !defined(XSD_USE_CHAR)

#ifndef XSD_CXX_TREE_TRAITS_IXX_WCHAR
#define XSD_CXX_TREE_TRAITS_IXX_WCHAR

namespace xsd
{
  namespace cxx
  {
    namespace tree
    {
      template <>
      inline
      traits<bool>::type traits<bool>::
      create<wchar_t> (xml::dom::element<wchar_t> const& e)
      {
        return (e.value () == L"true") || (e.value () == L"1");
      }

      template <>
      inline
      traits<bool>::type traits<bool>::
      create<wchar_t> (xml::dom::attribute<wchar_t> const& a)
      {
        return (a.value () == L"true") || (a.value () == L"1");
      }

      template <>
      inline
      traits<bool>::type traits<bool>::
      create<wchar_t> (std::basic_string<wchar_t> const& s,
                       xml::dom::element<wchar_t> const&)
      {
        return (s == L"true") || (s == L"1");
      }
    }
  }
}

#endif // XSD_CXX_TREE_TRAITS_IXX_WCHAR
#endif // XSD_USE_WCHAR

